<?php

declare(strict_types=1);

namespace DoctrineMigrations;

use Doctrine\DBAL\Schema\Schema;
use Doctrine\Migrations\AbstractMigration;

/**
 * Auto-generated Migration: Please modify to your needs!
 */
final class Version20240321041835 extends AbstractMigration
{
    public function getDescription(): string
    {
        return '';
    }

    public function up(Schema $schema): void
    {
        // this up() migration is auto-generated, please modify it to your needs
        $this->addSql('CREATE SEQUENCE collectionner_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE collectionneur_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE piece_caracteristique_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE SEQUENCE piece_tranche_id_seq INCREMENT BY 1 MINVALUE 1 START 1');
        $this->addSql('CREATE TABLE collectionner (id SERIAL, collectionneur_id_id INT NOT NULL, piece_modele_id_id INT NOT NULL, qte_collection INT NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE INDEX IDX_2C8123078A1D04BF ON collectionner (collectionneur_id_id)');
        $this->addSql('CREATE INDEX IDX_2C8123072BA29EFA ON collectionner (piece_modele_id_id)');
        $this->addSql('CREATE TABLE collectionneur (id SERIAL, collectionneur_nom VARCHAR(250) NOT NULL, collectionneur_prenom VARCHAR(250) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE TABLE piece_caracteristique (id SERIAL, piece_modele_id_id INT NOT NULL, piece_face_commune VARCHAR(250) NOT NULL, piece_masse INT NOT NULL, piece_taille INT NOT NULL, piece_materiau VARCHAR(75) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE INDEX IDX_215E09A32BA29EFA ON piece_caracteristique (piece_modele_id_id)');
        $this->addSql('CREATE TABLE piece_tranche (id SERIAL, piece_modele_id_id INT NOT NULL, piece_tranche VARCHAR(250) NOT NULL, PRIMARY KEY(id))');
        $this->addSql('CREATE INDEX IDX_7AD14B292BA29EFA ON piece_tranche (piece_modele_id_id)');
        $this->addSql('ALTER TABLE collectionner ADD CONSTRAINT FK_2C8123078A1D04BF FOREIGN KEY (collectionneur_id_id) REFERENCES collectionneur (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE collectionner ADD CONSTRAINT FK_2C8123072BA29EFA FOREIGN KEY (piece_modele_id_id) REFERENCES piece_modele (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE piece_caracteristique ADD CONSTRAINT FK_215E09A32BA29EFA FOREIGN KEY (piece_modele_id_id) REFERENCES piece_modele (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
        $this->addSql('ALTER TABLE piece_tranche ADD CONSTRAINT FK_7AD14B292BA29EFA FOREIGN KEY (piece_modele_id_id) REFERENCES piece_modele (id) NOT DEFERRABLE INITIALLY IMMEDIATE');
    }

    public function down(Schema $schema): void
    {
        // this down() migration is auto-generated, please modify it to your needs
        $this->addSql('CREATE SCHEMA public');
        $this->addSql('DROP SEQUENCE collectionner_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE collectionneur_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE piece_caracteristique_id_seq CASCADE');
        $this->addSql('DROP SEQUENCE piece_tranche_id_seq CASCADE');
        $this->addSql('ALTER TABLE collectionner DROP CONSTRAINT FK_2C8123078A1D04BF');
        $this->addSql('ALTER TABLE collectionner DROP CONSTRAINT FK_2C8123072BA29EFA');
        $this->addSql('ALTER TABLE piece_caracteristique DROP CONSTRAINT FK_215E09A32BA29EFA');
        $this->addSql('ALTER TABLE piece_tranche DROP CONSTRAINT FK_7AD14B292BA29EFA');
        $this->addSql('DROP TABLE collectionner');
        $this->addSql('DROP TABLE collectionneur');
        $this->addSql('DROP TABLE piece_caracteristique');
        $this->addSql('DROP TABLE piece_tranche');
    }
}
